//Catmul Rom splines, see www.mvps.org/directx/articles/catmull/

float[][] myPoints = new float[4][2]; //four points 

void iniPoints(){
     myPoints[0][0] = 10;
     myPoints[0][1] = 10;
     myPoints[1][0] = 20;
     myPoints[1][1] = 20;
     myPoints[2][0] = 30;
     myPoints[2][1] = 10;
     myPoints[3][0] = 40;
     myPoints[3][1] = 20;
}

void addPoint(float newx, float newy){
     myPoints[0][0] = myPoints[1][0];
     myPoints[0][1] = myPoints[1][1];
     myPoints[1][0] = myPoints[2][0];
     myPoints[1][1] = myPoints[2][1];
     myPoints[2][0] = myPoints[3][0];
     myPoints[2][1] = myPoints[3][1];
     myPoints[3][0] = newx;
     myPoints[3][1] = newy;
}

float catmullromPolynomial(float x0, float x1, float x2, float x3, float t){
      //weigthed version of x0,x1,x2,x3 using Catmull-Rom's polynomial
      return 0.5 * (-t + 2*t*t - t*t*t)  * x0 
           + 0.5 * (2 - 5*t*t + 3*t*t*t) * x1 
           + 0.5 * (t + 4*t*t - 3*t*t*t) * x2 
           + 0.5 * (-t*t + t*t*t) * x3;
}

void myCurve(float[][] p){
     //draw the curve as connected line segments
     //p must contains four points as x and y
     float prev_x = p[1][0];
     float prev_y = p[1][1];
     strokeWeight(.5);
     for (int i=0; i <= 100; i++){
          float t = i * 0.01;
          float x = catmullromPolynomial(p[0][0],p[1][0],p[2][0],p[3][0],t);
          float y = catmullromPolynomial(p[0][1],p[1][1],p[2][1],p[3][1],t);
          stroke(0,255,0); line(prev_x,prev_y,x,y); stroke(0);
          prev_x = x;
          prev_y = y;
     }
}